(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("KontentSmartLink", [], factory);
	else if(typeof exports === 'object')
		exports["KontentSmartLink"] = factory();
	else
		root["KontentSmartLink"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var plugin_1 = __webpack_require__(/*! ./plugin */ "./src/plugin.ts");
Object.defineProperty(exports, "default", { enumerable: true, get: function () { return plugin_1.default; } });
var link_1 = __webpack_require__(/*! ./utils/link */ "./src/utils/link.ts");
Object.defineProperty(exports, "buildKontentLink", { enumerable: true, get: function () { return link_1.buildKontentLink; } });
Object.defineProperty(exports, "buildElementLink", { enumerable: true, get: function () { return link_1.buildElementLink; } });
Object.defineProperty(exports, "buildComponentElementLink", { enumerable: true, get: function () { return link_1.buildComponentElementLink; } });


/***/ }),

/***/ "./src/lib/EventManager.ts":
/*!*********************************!*\
  !*** ./src/lib/EventManager.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.EventManager = void 0;
var EventManager = /** @class */ (function () {
    function EventManager() {
        var _this = this;
        this.listeners = new Map();
        this.on = function (event, listener) {
            var _a, _b;
            var newListeners = (_b = (_a = _this.listeners.get(event)) === null || _a === void 0 ? void 0 : _a.add(listener)) !== null && _b !== void 0 ? _b : new Set([listener]);
            _this.listeners.set(event, newListeners);
        };
        this.off = function (event, listener) {
            var _a;
            (_a = _this.listeners.get(event)) === null || _a === void 0 ? void 0 : _a.delete(listener);
        };
        this.emit = function (event, data) {
            var listeners = _this.listeners.get(event);
            if (listeners && listeners.size > 0) {
                listeners.forEach(function (callback) {
                    callback(data);
                });
            }
        };
        this.removeAllListeners = function () {
            _this.listeners = new Map();
        };
    }
    return EventManager;
}());
exports.EventManager = EventManager;


/***/ }),

/***/ "./src/lib/HighlightRenderer.ts":
/*!**************************************!*\
  !*** ./src/lib/HighlightRenderer.ts ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HighlightRenderer = exports.HighlighterElementTag = exports.HighlighterContainerTag = void 0;
var node_1 = __webpack_require__(/*! ../utils/node */ "./src/utils/node.ts");
exports.HighlighterContainerTag = 'KONTENT-SMART-LINK-OVERLAY';
exports.HighlighterElementTag = 'KONTENT-SMART-LINK-ELEMENT';
var HighlightRenderer = /** @class */ (function () {
    function HighlightRenderer() {
        var _this = this;
        this.destroy = function () {
            _this.clear();
            _this.defaultContainer.remove();
        };
        this.selectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.classList.add('kontent-smart-link__node--selected');
                highlight.classList.add('selected');
            }
        };
        this.deselectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.classList.remove('kontent-smart-link__node--selected');
                highlight.classList.remove('selected');
            }
        };
        this.render = function (nodes) {
            var e_1, _a, e_2, _b, e_3, _c;
            var _d;
            if (nodes.size === 0) {
                _this.clear();
            }
            else {
                var newHighlightByNode = new Map();
                try {
                    for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                        var node = nodes_1_1.value;
                        var nodeRect = node.getBoundingClientRect();
                        // This check is needed to prevent highlight rendering for the "flat" elements (height or/and width === 0),
                        // because those elements are basically invisible and cannot be clicked.
                        var isFlat = nodeRect.height === 0 || nodeRect.width === 0;
                        if (!isFlat) {
                            var _e = __read(node_1.getParentForHighlight(node), 2), parentElement = _e[0], parentMetadata = _e[1];
                            var highlight = (_d = _this.highlightByNode.get(node)) !== null && _d !== void 0 ? _d : _this.createHighlight(parentElement);
                            if (parentElement) {
                                var parentRect = parentElement.getBoundingClientRect();
                                var container = _this.containerByParent.get(parentElement);
                                if (container) {
                                    if (!(parentMetadata === null || parentMetadata === void 0 ? void 0 : parentMetadata.hasRelativePosition)) {
                                        // When parent element is not relatively positioned it means that highlight
                                        // will be positioned relatively to some other element. That is why we need
                                        // to keep in mind all of the scroll offsets on the way to this relative element.
                                        var _f = __read(node_1.getRelativeScrollOffset(parentElement), 2), scrollOffsetTop = _f[0], scrollOffsetLeft = _f[1];
                                        container.style.height = parentRect.height + "px";
                                        container.style.width = parentRect.width + "px";
                                        container.style.top = parentElement.offsetTop - scrollOffsetTop + "px";
                                        container.style.left = parentElement.offsetLeft - scrollOffsetLeft + "px";
                                        if (parentMetadata === null || parentMetadata === void 0 ? void 0 : parentMetadata.hasRestrictedOverflow) {
                                            // When parent element has not relative position but its overflow is restricted
                                            // we need to hide overflow of the container as well to prevent
                                            // highlights from appearing for hidden content.
                                            container.classList.add('kontent-smart-link-overlay--restricted');
                                        }
                                    }
                                }
                                if ((parentMetadata === null || parentMetadata === void 0 ? void 0 : parentMetadata.hasRelativePosition) && (parentMetadata === null || parentMetadata === void 0 ? void 0 : parentMetadata.hasRestrictedOverflow)) {
                                    highlight.style.top = nodeRect.top - parentRect.top + parentElement.scrollTop + "px";
                                    highlight.style.left = nodeRect.left - parentRect.left + parentElement.scrollLeft + "px";
                                }
                                else {
                                    highlight.style.top = nodeRect.top - parentRect.top + "px";
                                    highlight.style.left = nodeRect.left - parentRect.left + "px";
                                }
                            }
                            else {
                                // When there is no ancestor with relative position or restricted overflow (hidden, scroll, etc.)
                                // highlight is placed into the body and page offset is used.
                                highlight.style.top = nodeRect.top + window.pageYOffset + "px";
                                highlight.style.left = nodeRect.left + window.pageXOffset + "px";
                            }
                            highlight.style.width = nodeRect.width + "px";
                            highlight.style.height = nodeRect.height + "px";
                            newHighlightByNode.set(node, highlight);
                            _this.highlightByNode.delete(node);
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                try {
                    for (var _g = __values(_this.highlightByNode.entries()), _h = _g.next(); !_h.done; _h = _g.next()) {
                        var _j = __read(_h.value, 2), node = _j[0], highlight = _j[1];
                        highlight.remove();
                        _this.highlightByNode.delete(node);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_h && !_h.done && (_b = _g.return)) _b.call(_g);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                try {
                    for (var _k = __values(_this.containerByParent.entries()), _l = _k.next(); !_l.done; _l = _k.next()) {
                        var _m = __read(_l.value, 2), parent_1 = _m[0], container = _m[1];
                        if (container.children.length === 0) {
                            container.remove();
                            _this.containerByParent.delete(parent_1);
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_l && !_l.done && (_c = _k.return)) _c.call(_k);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
                _this.highlightByNode = newHighlightByNode;
            }
        };
        this.clear = function () {
            var e_4, _a, e_5, _b;
            try {
                for (var _c = __values(_this.highlightByNode.entries()), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var _e = __read(_d.value, 2), node = _e[0], highlight = _e[1];
                    highlight.remove();
                    _this.highlightByNode.delete(node);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_4) throw e_4.error; }
            }
            try {
                for (var _f = __values(_this.containerByParent.entries()), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var _h = __read(_g.value, 2), parent_2 = _h[0], container = _h[1];
                    container.remove();
                    _this.containerByParent.delete(parent_2);
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                }
                finally { if (e_5) throw e_5.error; }
            }
            _this.highlightByNode = new Map();
            _this.containerByParent = new Map();
            _this.defaultContainer.innerHTML = '';
        };
        this.createHighlight = function (parent) {
            var highlight = document.createElement(exports.HighlighterElementTag);
            var container = _this.createContainerIfNotExist(parent);
            container.appendChild(highlight);
            return highlight;
        };
        this.createContainerIfNotExist = function (parent) {
            if (!parent) {
                return _this.defaultContainer;
            }
            if (_this.containerByParent.has(parent)) {
                return _this.containerByParent.get(parent);
            }
            var container = document.createElement(exports.HighlighterContainerTag);
            parent.appendChild(container);
            _this.containerByParent.set(parent, container);
            return container;
        };
        this.containerByParent = new Map();
        this.highlightByNode = new Map();
        this.defaultContainer = HighlightRenderer.createDefaultContainer();
    }
    HighlightRenderer.createDefaultContainer = function () {
        var container = document.createElement(exports.HighlighterContainerTag);
        container.classList.add('kontent-smart-link-default-overlay');
        window.document.body.appendChild(container);
        return container;
    };
    return HighlightRenderer;
}());
exports.HighlightRenderer = HighlightRenderer;


/***/ }),

/***/ "./src/lib/IFrameCommunicator.ts":
/*!***************************************!*\
  !*** ./src/lib/IFrameCommunicator.ts ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.IFrameCommunicator = exports.IFrameMessageType = void 0;
var iframe_1 = __webpack_require__(/*! ../utils/iframe */ "./src/utils/iframe.ts");
var EventManager_1 = __webpack_require__(/*! ./EventManager */ "./src/lib/EventManager.ts");
var IFrameMessageType;
(function (IFrameMessageType) {
    IFrameMessageType["ElementClicked"] = "kontent-smart-link:element:clicked";
    IFrameMessageType["Initialized"] = "kontent-smart-link:initialized";
    IFrameMessageType["Status"] = "kontent-smart-link:status";
})(IFrameMessageType = exports.IFrameMessageType || (exports.IFrameMessageType = {}));
var IFrameCommunicator = /** @class */ (function () {
    function IFrameCommunicator() {
        var _this = this;
        this.addMessageListener = function (type, listener) {
            _this.events.on(type, listener);
        };
        this.removeMessageListener = function (type, listener) {
            _this.events.off(type, listener);
        };
        this.sendMessage = function (type, data) {
            if (!iframe_1.isInsideIFrame()) {
                console.error("Warning: can't send an iframe message, because the application is not hosted in an iframe");
                return;
            }
            var message = { type: type, data: data };
            window.parent.postMessage(message, '*');
        };
        this.onMessage = function (event) {
            if (!event.data)
                return;
            var message = event.data;
            _this.events.emit(message.type, message.data);
        };
        this.events = new EventManager_1.EventManager();
        window.addEventListener('message', this.onMessage, true);
    }
    IFrameCommunicator.prototype.destroy = function () {
        this.events.removeAllListeners();
        window.removeEventListener('message', this.onMessage, true);
    };
    return IFrameCommunicator;
}());
exports.IFrameCommunicator = IFrameCommunicator;


/***/ }),

/***/ "./src/lib/NodeSmartLinkProvider.ts":
/*!******************************************!*\
  !*** ./src/lib/NodeSmartLinkProvider.ts ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeSmartLinkProvider = exports.NodeSmartLinkProviderEventType = void 0;
var dataAttributes_1 = __webpack_require__(/*! ../utils/dataAttributes */ "./src/utils/dataAttributes.ts");
var EventManager_1 = __webpack_require__(/*! ./EventManager */ "./src/lib/EventManager.ts");
var HighlightRenderer_1 = __webpack_require__(/*! ./HighlightRenderer */ "./src/lib/HighlightRenderer.ts");
var NodeSmartLinkProviderEventType;
(function (NodeSmartLinkProviderEventType) {
    NodeSmartLinkProviderEventType["ElementClicked"] = "kontent-smart-link:element:clicked";
})(NodeSmartLinkProviderEventType = exports.NodeSmartLinkProviderEventType || (exports.NodeSmartLinkProviderEventType = {}));
var NodeSmartLinkProvider = /** @class */ (function () {
    function NodeSmartLinkProvider() {
        var _this = this;
        this.enabled = false;
        this.renderingTimeoutId = 0;
        this.observedElements = new Set();
        this.visibleElements = new Set();
        this.destroy = function () {
            _this.disable();
            _this.renderer.destroy();
        };
        this.addEventListener = function (type, listener) {
            _this.events.on(type, listener);
        };
        this.removeEventListener = function (type, listener) {
            _this.events.off(type, listener);
        };
        this.enable = function () {
            if (_this.enabled)
                return;
            _this.startRenderingInterval();
            _this.listenToGlobalEvents();
            _this.observeDomMutations();
            _this.enabled = true;
        };
        this.disable = function () {
            if (!_this.enabled)
                return;
            _this.stopRenderingInterval();
            _this.unlistenToGlobalEvents();
            _this.disconnectObservers();
            _this.renderer.clear();
            _this.enabled = false;
        };
        this.highlightVisibleElements = function () {
            requestAnimationFrame(function () {
                _this.renderer.render(_this.visibleElements);
            });
        };
        /**
         * Start an interval rendering (1s) that will re-render highlights for all visible elements using `setTimeout`.
         * It helps to adjust highlights position even in situations that are currently not supported by
         * the SDK (e.g. element position change w/o animations, some infinite animations and other possible unhandled cases)
         * for better user experience.
         */
        this.startRenderingInterval = function () {
            _this.highlightVisibleElements();
            _this.renderingTimeoutId = setTimeout(_this.startRenderingInterval, 1000);
        };
        this.stopRenderingInterval = function () {
            if (_this.renderingTimeoutId) {
                clearTimeout(_this.renderingTimeoutId);
                _this.renderingTimeoutId = 0;
            }
        };
        this.listenToGlobalEvents = function () {
            window.addEventListener('scroll', _this.highlightVisibleElements, { capture: true });
            window.addEventListener('resize', _this.highlightVisibleElements, { passive: true });
            window.addEventListener('animationend', _this.highlightVisibleElements, { passive: true, capture: true });
            window.addEventListener('transitionend', _this.highlightVisibleElements, { passive: true, capture: true });
            window.addEventListener('click', _this.onElementClick, { capture: true });
        };
        this.unlistenToGlobalEvents = function () {
            window.removeEventListener('scroll', _this.highlightVisibleElements, { capture: true });
            window.removeEventListener('resize', _this.highlightVisibleElements);
            window.removeEventListener('animationend', _this.highlightVisibleElements, { capture: true });
            window.removeEventListener('transitionend', _this.highlightVisibleElements, { capture: true });
            window.removeEventListener('click', _this.onElementClick, { capture: true });
        };
        this.observeDomMutations = function () {
            if (_this.enabled)
                return;
            document.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]").forEach(function (element) {
                if (element instanceof HTMLElement) {
                    _this.observeElementVisibility(element);
                }
            });
            _this.mutationObserver.observe(window.document.body, {
                childList: true,
                subtree: true,
            });
        };
        this.disconnectObservers = function () {
            _this.mutationObserver.disconnect();
            _this.intersectionObserver.disconnect();
            _this.observedElements.forEach(function (element) {
                _this.unobserveElementVisibility(element);
            });
            _this.observedElements = new Set();
            _this.visibleElements = new Set();
        };
        this.observeElementVisibility = function (element) {
            if (_this.observedElements.has(element))
                return;
            _this.intersectionObserver.observe(element);
            _this.observedElements.add(element);
            element.addEventListener('mousemove', _this.onElementMouseEnter);
            element.addEventListener('mouseleave', _this.onElementMouseLeave);
        };
        this.unobserveElementVisibility = function (element) {
            if (!_this.observedElements.has(element))
                return;
            _this.intersectionObserver.unobserve(element);
            _this.observedElements.delete(element);
            _this.visibleElements.delete(element);
            element.removeEventListener('mousemove', _this.onElementMouseEnter);
            element.removeEventListener('mouseleave', _this.onElementMouseLeave);
        };
        this.onDomMutation = function (mutations) {
            var e_1, _a, e_2, _b, e_3, _c, e_4, _d, e_5, _e;
            var attrName = dataAttributes_1.dataToDatasetAttributeName(dataAttributes_1.DataAttribute.ElementCodename);
            var relevantMutations = mutations.filter(function (mutation) {
                return mutation.target instanceof Element &&
                    mutation.type === 'childList' &&
                    ![HighlightRenderer_1.HighlighterElementTag, HighlightRenderer_1.HighlighterContainerTag].includes(mutation.target.tagName) &&
                    Array.from(mutation.addedNodes).some(function (node) { return node.tagName !== HighlightRenderer_1.HighlighterElementTag; }) &&
                    Array.from(mutation.removedNodes).some(function (node) { return node.tagName !== HighlightRenderer_1.HighlighterElementTag; });
            });
            try {
                for (var relevantMutations_1 = __values(relevantMutations), relevantMutations_1_1 = relevantMutations_1.next(); !relevantMutations_1_1.done; relevantMutations_1_1 = relevantMutations_1.next()) {
                    var mutation = relevantMutations_1_1.value;
                    try {
                        for (var _f = (e_2 = void 0, __values(mutation.addedNodes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var node = _g.value;
                            if (!(node instanceof HTMLElement))
                                continue;
                            if (node.dataset[attrName]) {
                                _this.observeElementVisibility(node);
                            }
                            try {
                                for (var _h = (e_3 = void 0, __values(node.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]"))), _j = _h.next(); !_j.done; _j = _h.next()) {
                                    var element = _j.value;
                                    if (!(element instanceof HTMLElement))
                                        continue;
                                    _this.observeElementVisibility(element);
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    try {
                        for (var _k = (e_4 = void 0, __values(mutation.removedNodes)), _l = _k.next(); !_l.done; _l = _k.next()) {
                            var node = _l.value;
                            if (!(node instanceof HTMLElement))
                                continue;
                            if (node.dataset[attrName]) {
                                _this.unobserveElementVisibility(node);
                            }
                            try {
                                for (var _m = (e_5 = void 0, __values(node.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]"))), _o = _m.next(); !_o.done; _o = _m.next()) {
                                    var element = _o.value;
                                    if (!(element instanceof HTMLElement))
                                        continue;
                                    _this.unobserveElementVisibility(element);
                                }
                            }
                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                            finally {
                                try {
                                    if (_o && !_o.done && (_e = _m.return)) _e.call(_m);
                                }
                                finally { if (e_5) throw e_5.error; }
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_l && !_l.done && (_d = _k.return)) _d.call(_k);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (relevantMutations_1_1 && !relevantMutations_1_1.done && (_a = relevantMutations_1.return)) _a.call(relevantMutations_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (relevantMutations.length > 0) {
                _this.highlightVisibleElements();
            }
        };
        this.onElementVisibilityChange = function (entries) {
            var e_6, _a;
            var filteredEntries = entries.filter(function (entry) { return entry.target instanceof HTMLElement; });
            try {
                for (var filteredEntries_1 = __values(filteredEntries), filteredEntries_1_1 = filteredEntries_1.next(); !filteredEntries_1_1.done; filteredEntries_1_1 = filteredEntries_1.next()) {
                    var entry = filteredEntries_1_1.value;
                    var target = entry.target;
                    if (entry.isIntersecting) {
                        _this.visibleElements.add(target);
                    }
                    else {
                        _this.visibleElements.delete(target);
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (filteredEntries_1_1 && !filteredEntries_1_1.done && (_a = filteredEntries_1.return)) _a.call(filteredEntries_1);
                }
                finally { if (e_6) throw e_6.error; }
            }
            if (filteredEntries.length > 0) {
                _this.highlightVisibleElements();
            }
        };
        this.onElementClick = function (event) {
            var attributes = dataAttributes_1.getDataAttributesFromEventPath(event);
            if (attributes.has(dataAttributes_1.DataAttribute.ElementCodename)) {
                event.preventDefault();
                _this.events.emit(NodeSmartLinkProviderEventType.ElementClicked, {
                    projectId: attributes.get(dataAttributes_1.DataAttribute.ProjectId),
                    languageCodename: attributes.get(dataAttributes_1.DataAttribute.LanguageCodename),
                    itemId: attributes.get(dataAttributes_1.DataAttribute.ItemId),
                    contentComponentId: attributes.get(dataAttributes_1.DataAttribute.ComponentId),
                    elementCodename: attributes.get(dataAttributes_1.DataAttribute.ElementCodename),
                });
            }
        };
        this.onElementMouseEnter = function (event) {
            var node = event.currentTarget;
            _this.renderer.selectNode(node);
        };
        this.onElementMouseLeave = function (event) {
            var node = event.currentTarget;
            _this.renderer.deselectNode(node);
        };
        this.mutationObserver = new MutationObserver(this.onDomMutation);
        this.intersectionObserver = new IntersectionObserver(this.onElementVisibilityChange);
        this.events = new EventManager_1.EventManager();
        this.renderer = new HighlightRenderer_1.HighlightRenderer();
    }
    return NodeSmartLinkProvider;
}());
exports.NodeSmartLinkProvider = NodeSmartLinkProvider;


/***/ }),

/***/ "./src/plugin.ts":
/*!***********************!*\
  !*** ./src/plugin.ts ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var iframe_1 = __webpack_require__(/*! ./utils/iframe */ "./src/utils/iframe.ts");
var link_1 = __webpack_require__(/*! ./utils/link */ "./src/utils/link.ts");
var IFrameCommunicator_1 = __webpack_require__(/*! ./lib/IFrameCommunicator */ "./src/lib/IFrameCommunicator.ts");
var NodeSmartLinkProvider_1 = __webpack_require__(/*! ./lib/NodeSmartLinkProvider */ "./src/lib/NodeSmartLinkProvider.ts");
var storage_1 = __webpack_require__(/*! ./utils/storage */ "./src/utils/storage.ts");
var validation_1 = __webpack_require__(/*! ./utils/validation */ "./src/utils/validation.ts");
var query_1 = __webpack_require__(/*! ./utils/query */ "./src/utils/query.ts");
var initialState = {
    queryTimerId: 0,
};
var defaultConfiguration = {
    languageCodename: null,
    projectId: null,
    queryParam: 'kontent-smart-link-enabled',
};
var Plugin = /** @class */ (function () {
    function Plugin(configuration) {
        var _this = this;
        this.destroy = function () {
            var _a;
            _this.unwatchQueryParams();
            _this.nodeSmartLinkProvider.destroy();
            (_a = _this.iFrameCommunicator) === null || _a === void 0 ? void 0 : _a.destroy();
        };
        this.updateConfiguration = function (configuration) {
            _this.configuration = __assign(__assign({}, _this.configuration), configuration);
        };
        this.updateState = function (state) {
            _this.state = __assign(__assign({}, _this.state), state);
        };
        this.initializeIFrameCommunication = function () {
            if (!iframe_1.isInsideIFrame() || _this.iFrameCommunicator) {
                throw new Error('Cannot initialize iframe communication while not inside the iframe.');
            }
            _this.iFrameCommunicator = new IFrameCommunicator_1.IFrameCommunicator();
            var storage = storage_1.createStorage('kontent-smart-link:iframe-settings');
            var stored = storage.get();
            var enabled = stored !== null ? stored === null || stored === void 0 ? void 0 : stored.enabled : true;
            if (enabled) {
                _this.nodeSmartLinkProvider.enable();
            }
            _this.iFrameCommunicator.addMessageListener(IFrameCommunicator_1.IFrameMessageType.Status, function (data) {
                if (!data || !_this.nodeSmartLinkProvider)
                    return;
                _this.toggleNodeSmartLinkProvider(data.enabled);
                storage.set({
                    enabled: data.enabled,
                });
            });
            _this.iFrameCommunicator.sendMessage(IFrameCommunicator_1.IFrameMessageType.Initialized, {
                projectId: _this.configuration.projectId,
                languageCodename: _this.configuration.languageCodename,
                enabled: enabled,
            });
        };
        this.watchQueryParams = function () {
            if (iframe_1.isInsideIFrame()) {
                throw new Error('No need to watch query params inside the iframe.');
            }
            if (_this.state.queryTimerId) {
                clearTimeout(_this.state.queryTimerId);
            }
            var isPluginEnabled = query_1.isQueryParamPresent(_this.configuration.queryParam);
            var hasChanged = _this.nodeSmartLinkProvider.enabled !== isPluginEnabled;
            if (hasChanged) {
                _this.toggleNodeSmartLinkProvider(isPluginEnabled);
            }
            _this.updateState({
                queryTimerId: setTimeout(_this.watchQueryParams, 1000),
            });
        };
        this.unwatchQueryParams = function () {
            clearTimeout(_this.state.queryTimerId);
        };
        this.listenToHighlighterEvents = function () {
            _this.nodeSmartLinkProvider.addEventListener(NodeSmartLinkProvider_1.NodeSmartLinkProviderEventType.ElementClicked, _this.onElementClick);
        };
        this.onElementClick = function (elementClickData) {
            var data = __assign(__assign({}, elementClickData), { projectId: elementClickData.projectId || _this.configuration.projectId || undefined, languageCodename: elementClickData.languageCodename || _this.configuration.languageCodename || undefined });
            if (validation_1.validateElementClickMessageData(data)) {
                if (iframe_1.isInsideIFrame() && _this.iFrameCommunicator) {
                    _this.iFrameCommunicator.sendMessage(IFrameCommunicator_1.IFrameMessageType.ElementClicked, data);
                }
                else {
                    var link = link_1.buildKontentLink(data);
                    window.open(link, '_blank');
                }
            }
        };
        this.toggleNodeSmartLinkProvider = function (force) {
            var shouldEnable = typeof force !== 'undefined' ? force : !_this.nodeSmartLinkProvider.enabled;
            if (shouldEnable) {
                _this.nodeSmartLinkProvider.enable();
            }
            else {
                _this.nodeSmartLinkProvider.disable();
            }
        };
        this.nodeSmartLinkProvider = new NodeSmartLinkProvider_1.NodeSmartLinkProvider();
        this.state = initialState;
        this.configuration = __assign(__assign({}, defaultConfiguration), configuration);
        if (iframe_1.isInsideIFrame()) {
            this.initializeIFrameCommunication();
        }
        else {
            this.watchQueryParams();
        }
        this.listenToHighlighterEvents();
    }
    return Plugin;
}());
var PluginWrapper = /** @class */ (function () {
    function PluginWrapper() {
        var _this = this;
        this.plugin = null;
        this.destroy = function () {
            var _a;
            (_a = _this.plugin) === null || _a === void 0 ? void 0 : _a.destroy();
            _this.plugin = null;
        };
        this.setConfiguration = function (configuration) {
            if (!_this.plugin) {
                throw new Error('KontentSmartLink is not initialized or has already been destroyed.');
            }
            else {
                _this.plugin.updateConfiguration(configuration);
            }
        };
    }
    PluginWrapper.initializeOnLoad = function (configuration) {
        return new Promise(function (resolve) {
            window.addEventListener('load', function () {
                resolve(PluginWrapper.initialize(configuration));
            });
        });
    };
    PluginWrapper.initialize = function (configuration) {
        if (!PluginWrapper.instance) {
            PluginWrapper.instance = new PluginWrapper();
        }
        if (!PluginWrapper.instance.plugin) {
            PluginWrapper.instance.plugin = new Plugin(configuration);
        }
        return PluginWrapper.instance;
    };
    return PluginWrapper;
}());
exports.default = PluginWrapper;


/***/ }),

/***/ "./src/utils/dataAttributes.ts":
/*!*************************************!*\
  !*** ./src/utils/dataAttributes.ts ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDataAttributesFromEventPath = exports.dataToDatasetAttributeName = exports.DataAttribute = void 0;
exports.DataAttribute = {
    ElementCodename: 'data-kontent-element-codename',
    ComponentId: 'data-kontent-component-id',
    ItemId: 'data-kontent-item-id',
    LanguageCodename: 'data-kontent-language-codename',
    ProjectId: 'data-kontent-project-id',
};
var DataAttributeHierarchy = [
    exports.DataAttribute.ProjectId,
    exports.DataAttribute.LanguageCodename,
    exports.DataAttribute.ItemId,
    exports.DataAttribute.ComponentId,
    exports.DataAttribute.ElementCodename,
];
var DataAttributeParsingOrder = DataAttributeHierarchy.slice().reverse();
var OptionalDataAttributes = [exports.DataAttribute.ComponentId];
function getHigherDataAttributes(attributeName) {
    var attributeIndex = DataAttributeHierarchy.indexOf(attributeName);
    return DataAttributeHierarchy.slice(0, attributeIndex);
}
function dataToDatasetAttributeName(dataAttributeName) {
    return dataAttributeName.replace(/^data-/, '').replace(/-./g, function (x) { return x.toUpperCase()[1]; });
}
exports.dataToDatasetAttributeName = dataToDatasetAttributeName;
function getDataAttributesFromEventPath(event) {
    var e_1, _a, e_2, _b, e_3, _c;
    var path = event.composedPath();
    var parsed = new Map();
    try {
        for (var path_1 = __values(path), path_1_1 = path_1.next(); !path_1_1.done; path_1_1 = path_1.next()) {
            var node = path_1_1.value;
            if (!(node instanceof HTMLElement))
                continue;
            try {
                for (var DataAttributeParsingOrder_1 = (e_2 = void 0, __values(DataAttributeParsingOrder)), DataAttributeParsingOrder_1_1 = DataAttributeParsingOrder_1.next(); !DataAttributeParsingOrder_1_1.done; DataAttributeParsingOrder_1_1 = DataAttributeParsingOrder_1.next()) {
                    var attributeName = DataAttributeParsingOrder_1_1.value;
                    var datasetAttributeName = dataToDatasetAttributeName(attributeName);
                    var datasetAttributeValue = node.dataset[datasetAttributeName];
                    var isAttributeOptional = OptionalDataAttributes.includes(attributeName);
                    if (!datasetAttributeValue || parsed.has(attributeName))
                        continue;
                    // Higher attributes are attributes that are placed higher in the hierarchy, for example,
                    // for component id attribute those will be item id, language codename and project id.
                    var higherDataAttributes = getHigherDataAttributes(attributeName);
                    var areSomeHigherAttributesSet = higherDataAttributes.some(function (attr) { return parsed.has(attr); });
                    // If some higher attributes have already been parsed, it can mean two things:
                    // a) Current data attribute is optional and is not related to the current scope.
                    //    In that case it will be ignored.
                    //      Example:
                    //        <body data-kontent-project-id data-kontent-language-codename>
                    //          <div data-kontent-item-id data-kontent-component-id data-kontent-element-codename>
                    //            <!-- when parser comes to this element itemId and elementCodename are already parsed
                    //                 data-kontent-component-id is not related to them, so it should be ignored -->
                    //            <div data-kontent-item-id data-kontent-element-codename></div>
                    //          </div>
                    //        </body>
                    // b) Parsed data is related to some lower scope (or invalid) and should be cleared.
                    //      Example:
                    //        <body data-kontent-project-id data-kontent-language-codename>
                    //          <div data-kontent-item-id data-kontent-element-codename>
                    //            <div data-kontent-item-id>
                    //               <!-- if you click on this element, item id will be parsed, but it is not related to the
                    //                  data-kontent-element-codename above it, and this value must be cleared -->
                    //            </div>
                    //          </div>
                    //        </body>
                    if (areSomeHigherAttributesSet) {
                        if (isAttributeOptional)
                            continue;
                        try {
                            for (var higherDataAttributes_1 = (e_3 = void 0, __values(higherDataAttributes)), higherDataAttributes_1_1 = higherDataAttributes_1.next(); !higherDataAttributes_1_1.done; higherDataAttributes_1_1 = higherDataAttributes_1.next()) {
                                var attr = higherDataAttributes_1_1.value;
                                parsed.delete(attr);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (higherDataAttributes_1_1 && !higherDataAttributes_1_1.done && (_c = higherDataAttributes_1.return)) _c.call(higherDataAttributes_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    }
                    parsed.set(attributeName, datasetAttributeValue);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (DataAttributeParsingOrder_1_1 && !DataAttributeParsingOrder_1_1.done && (_b = DataAttributeParsingOrder_1.return)) _b.call(DataAttributeParsingOrder_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (path_1_1 && !path_1_1.done && (_a = path_1.return)) _a.call(path_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return parsed;
}
exports.getDataAttributesFromEventPath = getDataAttributesFromEventPath;


/***/ }),

/***/ "./src/utils/iframe.ts":
/*!*****************************!*\
  !*** ./src/utils/iframe.ts ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.isInsideIFrame = void 0;
function isInsideIFrame() {
    return window.self !== window.top;
}
exports.isInsideIFrame = isInsideIFrame;


/***/ }),

/***/ "./src/utils/link.ts":
/*!***************************!*\
  !*** ./src/utils/link.ts ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.buildKontentLink = exports.buildComponentElementLink = exports.buildElementLink = void 0;
function buildItemLink(projectId, languageCodename, itemId) {
    return "https://app.kontent.ai/goto/edit-item/project/" + projectId + "/variant-codename/" + languageCodename + "/item/" + itemId;
}
function buildElementLink(projectId, languageCodename, itemId, elementCodename) {
    return buildItemLink(projectId, languageCodename, itemId) + "/element/" + elementCodename;
}
exports.buildElementLink = buildElementLink;
function buildComponentElementLink(projectId, languageCodename, itemId, contentComponentId, componentElementCodename) {
    return buildItemLink(projectId, languageCodename, itemId) + "/component/" + contentComponentId + "/element/" + componentElementCodename;
}
exports.buildComponentElementLink = buildComponentElementLink;
function buildKontentLink(data) {
    if (data.contentComponentId) {
        return buildComponentElementLink(data.projectId, data.languageCodename, data.itemId, data.contentComponentId, data.elementCodename);
    }
    else {
        return buildElementLink(data.projectId, data.languageCodename, data.itemId, data.elementCodename);
    }
}
exports.buildKontentLink = buildKontentLink;


/***/ }),

/***/ "./src/utils/node.ts":
/*!***************************!*\
  !*** ./src/utils/node.ts ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.getRelativeScrollOffset = exports.getParentForHighlight = void 0;
function getParentForHighlight(node) {
    var parent = node.parentNode;
    if (parent instanceof HTMLElement) {
        var computedStyle = window.getComputedStyle(parent);
        var position = computedStyle.getPropertyValue('position');
        var overflow = computedStyle.getPropertyValue('overflow');
        var metadata = {
            hasRelativePosition: position === 'relative',
            hasRestrictedOverflow: overflow.split(' ').some(function (value) { return ['auto', 'scroll', 'clip', 'hidden'].includes(value); }),
        };
        return metadata.hasRelativePosition || metadata.hasRestrictedOverflow
            ? [parent, metadata]
            : getParentForHighlight(parent);
    }
    return [null, null];
}
exports.getParentForHighlight = getParentForHighlight;
function getRelativeScrollOffset(node) {
    if (!node || !(node instanceof HTMLElement)) {
        return [0, 0];
    }
    var offsetParent = node.offsetParent;
    var scrollTop = 0;
    var scrollLeft = 0;
    var currentNode = node;
    while (currentNode.parentElement) {
        currentNode = currentNode.parentElement;
        if (offsetParent && offsetParent.isSameNode(currentNode)) {
            break;
        }
        scrollTop += currentNode.scrollTop;
        scrollLeft += currentNode.scrollLeft;
    }
    return [scrollTop, scrollLeft];
}
exports.getRelativeScrollOffset = getRelativeScrollOffset;


/***/ }),

/***/ "./src/utils/query.ts":
/*!****************************!*\
  !*** ./src/utils/query.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.isQueryParamPresent = void 0;
function isQueryParamPresent(queryParam) {
    var regex = new RegExp("[?&]" + queryParam + "([=&]|$)", 'i');
    return regex.test(window.location.search);
}
exports.isQueryParamPresent = isQueryParamPresent;


/***/ }),

/***/ "./src/utils/storage.ts":
/*!******************************!*\
  !*** ./src/utils/storage.ts ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.createStorage = void 0;
function createStorage(key) {
    return {
        get: function () {
            var value = window.localStorage.getItem(key);
            return value ? JSON.parse(value) : null;
        },
        set: function (data) {
            var json = JSON.stringify(data);
            window.localStorage.setItem(key, json);
        },
        remove: function () {
            window.localStorage.removeItem(key);
        },
    };
}
exports.createStorage = createStorage;


/***/ }),

/***/ "./src/utils/validation.ts":
/*!*********************************!*\
  !*** ./src/utils/validation.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.validateElementClickMessageData = void 0;
function validateElementClickMessageData(data) {
    var errors = [];
    if (!data.projectId) {
        errors.push('Warning: project ID is required to handle element click.');
    }
    if (!data.languageCodename) {
        errors.push('Warning: language codename is required to handle element click.');
    }
    if (!data.itemId) {
        errors.push('Warning: item ID is required to handle element click.');
    }
    if (!data.elementCodename) {
        errors.push('Warning: element codename is required to handle element click.');
    }
    errors.forEach(function (error) {
        console.error(error);
    });
    return errors.length === 0;
}
exports.validateElementClickMessageData = validateElementClickMessageData;


/***/ })

/******/ })["default"];
});
//# sourceMappingURL=kontent-smart-link.umd.js.map