export interface IPluginConfiguration {
    readonly languageCodename: string | null;
    readonly projectId: string | null;
    readonly queryParam: string;
}
declare class PluginWrapper {
    private static instance;
    private plugin;
    static initializeOnLoad(configuration?: Partial<IPluginConfiguration>): Promise<PluginWrapper>;
    static initialize(configuration?: Partial<IPluginConfiguration>): PluginWrapper;
    destroy: () => void;
    setConfiguration: (configuration: Partial<IPluginConfiguration>) => void;
}
export default PluginWrapper;
